using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GemBehavior : MonoBehaviour
{
    private AudioSource _audioSource;
    [SerializeField] private AudioClip _gemSound;
    private GameObject _text;
    
    void Start()
    {
        _audioSource = GetComponent<AudioSource>();
        _text = transform.Find("ScoreText").gameObject;
        _text.SetActive(false);
    }

    private void OnTriggerEnter(Collider other)
    {
        _text.SetActive(true);
        _audioSource.PlayOneShot(_gemSound);
        // We hide the gem
        GetComponent<Renderer>().enabled = false;
        // We wait for the sound to finish playing
        StartCoroutine(WaitForSound());
        // We hide the text after 2 seconds
        StartCoroutine(WaitForText());
    }
    
    IEnumerator WaitForSound()
    {
        yield return new WaitForSeconds(_gemSound.length);
        Destroy(gameObject);
    }
    
    IEnumerator WaitForText()
    {
        yield return new WaitForSeconds(2);
        _text.SetActive(false);
    }
}
